#include <iostream>

using namespace std;

int main()
{
    int n, q; // n - ukupan broj dana kojima je uspeo da nadje plazmu, q - broj pitanja
    
    cin >> n >> q;
    
    int d[n], p[n]; // di - dan kada je nasao plazmu, pi - kolicina koju je nasao taj dan
    int k[q];
    
    for (int i = 0; i < n; i++) cin >> d[i] >> p[i];
    for (int i = 0; i < q; i++) cin >> k[i];
    
    
    int len = k[q - 1] + 1;
    int res[len] = { 0 };
    
    for (int i = 0; i < n; i++) {
        int lim = d[i] + p[i];
        for (int j = d[i]; j < lim && j < len; j++) {
            if (res[j] != 0) lim++;
            else res[j] = 1;
        }
    }
    
    for (int i = 1; i < len; i++) {
        res[i] = res[i] + res[i - 1];
    }
    
    for (int i = 0; i < q; i++) {
        cout << res[k[i]] << endl;
    }
    
    return 0;
}